/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.msp.role.GAddSceneState
 *  fire.msp.role.GRemoveSceneState
 *  fire.pb.GsClient
 *  fire.pb.attr.SRefreshRoleData
 *  fire.pb.buff.continual.BuffTimer
 *  fire.pb.buff.continual.ConstantlyBuff
 *  fire.pb.buff.continual.ConstantlyBuffConfig
 *  fire.pb.buff.continual.PeriodBuff
 *  fire.pb.buff.continual.PeriodBuffTimer
 *  fire.pb.effect.Module
 *  fire.pb.effect.Role
 *  fire.pb.effect.RoleImpl
 *  fire.pb.map.Role
 *  fire.pb.map.RoleManager
 *  fire.pb.skill.Result
 *  fire.pb.talk.MessageMgr
 *  fire.pb.timer.ScheduledFutureMap
 *  mkdb.Procedure
 *  mkio.Protocol
 *  xbean.Buff
 *  xbean.BuffRole
 *  xbean.Pod
 *  xbean.StoredBuffRole
 *  xtable.Buffroles
 *  xtable.Buffrolestodisk
 */
package fire.pb.buff;

import fire.msp.role.GAddSceneState;
import fire.msp.role.GRemoveSceneState;
import fire.pb.GsClient;
import fire.pb.attr.SRefreshRoleData;
import fire.pb.buff.Buff;
import fire.pb.buff.BuffAgent;
import fire.pb.buff.BuffClashs;
import fire.pb.buff.Module;
import fire.pb.buff.SBuffChangeResult;
import fire.pb.buff.continual.BuffTimer;
import fire.pb.buff.continual.ConstantlyBuff;
import fire.pb.buff.continual.ConstantlyBuffConfig;
import fire.pb.buff.continual.PeriodBuff;
import fire.pb.buff.continual.PeriodBuffTimer;
import fire.pb.effect.Role;
import fire.pb.effect.RoleImpl;
import fire.pb.map.RoleManager;
import fire.pb.skill.Result;
import fire.pb.talk.MessageMgr;
import fire.pb.timer.ScheduledFutureMap;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ScheduledFuture;
import mkdb.Procedure;
import mkio.Protocol;
import xbean.BuffRole;
import xbean.Pod;
import xbean.StoredBuffRole;
import xtable.Buffroles;
import xtable.Buffrolestodisk;

public class BuffRoleImpl
extends BuffAgent {
    private long roleId;
    private BuffRole buffRoleBean;
    private StoredBuffRole storedBuffRole;

    public BuffRoleImpl(long roleId) {
        this(roleId, false);
    }

    public BuffRoleImpl(long roleId, boolean readonly) {
        this.readonly = readonly;
        this.roleId = roleId;
        this.agentType = 1;
        if (readonly) {
            this.buffRoleBean = Buffroles.select((Long)roleId);
            this.storedBuffRole = Buffrolestodisk.select((Long)roleId);
        } else {
            this.buffRoleBean = Buffroles.get((Long)roleId);
            this.storedBuffRole = Buffrolestodisk.get((Long)roleId);
        }
        if (this.buffRoleBean == null) {
            if (readonly) {
                this.buffRoleBean = Pod.newBuffRoleData();
            } else {
                this.buffRoleBean = Pod.newBuffRole();
                Buffroles.insert((Long)roleId, (BuffRole)this.buffRoleBean);
            }
        }
        if (this.storedBuffRole == null) {
            if (readonly) {
                this.storedBuffRole = Pod.newStoredBuffRole();
            } else {
                this.storedBuffRole = Pod.newStoredBuffRole();
                Buffrolestodisk.insert((Long)roleId, (StoredBuffRole)this.storedBuffRole);
            }
        }
        this.agent = this.buffRoleBean.getBuffagent();
    }

    @Override
    public xbean.Buff getBuffBean(int buffId) {
        ConstantlyBuffConfig cbuffconf = Module.getInstance().getDefaultCBuffConfig(buffId);
        if (cbuffconf.isStoreToDisk()) {
            return (xbean.Buff)this.storedBuffRole.getBuffs().get(buffId);
        }
        return (xbean.Buff)this.agent.getBuffs().get(buffId);
    }

    @Override
    public xbean.Buff addBuffBean(xbean.Buff buffbean) {
        ConstantlyBuffConfig cbuffconf = Module.getInstance().getDefaultCBuffConfig(buffbean.getIndex());
        if (cbuffconf.isStoreToDisk()) {
            return this.storedBuffRole.getBuffs().put(buffbean.getIndex(), buffbean);
        }
        return this.agent.getBuffs().put(buffbean.getIndex(), buffbean);
    }

    @Override
    public xbean.Buff removeBuffBean(int buffId) {
        ConstantlyBuffConfig cbuffconf = Module.getInstance().getDefaultCBuffConfig(buffId);
        if (cbuffconf.isStoreToDisk()) {
            return (xbean.Buff)this.storedBuffRole.getBuffs().remove(buffId);
        }
        return (xbean.Buff)this.agent.getBuffs().remove(buffId);
    }

    @Override
    public boolean existBuffBean(int buffId) {
        ConstantlyBuffConfig cbuffconf = Module.getInstance().getDefaultCBuffConfig(buffId);
        if (cbuffconf.isStoreToDisk()) {
            return this.storedBuffRole.getBuffs().containsKey(buffId);
        }
        return this.agent.getBuffs().containsKey(buffId);
    }

    @Override
    public Map<Integer, xbean.Buff> getAllBuffBeans() {
        HashMap<Integer, xbean.Buff> buffbeans = new HashMap<Integer, xbean.Buff>();
        buffbeans.putAll(this.agent.getBuffs());
        buffbeans.putAll(this.storedBuffRole.getBuffs());
        return buffbeans;
    }

    @Override
    public BuffTimer getBuffTimer(int buffId, long time) {
        return new BuffTimer(this.roleId, buffId, time);
    }

    @Override
    public BuffTimer getBuffTimer(int buffId, long initialDelay, long period) {
        return this.getBuffTimer(buffId, initialDelay, period, -1);
    }

    @Override
    public BuffTimer getBuffTimer(int buffId, long initialDelay, long period, int count) {
        return new PeriodBuffTimer(this.roleId, buffId, initialDelay, period, -1);
    }

    @Override
    public boolean existState(int buffTypeId) {
        return Module.existState(this.roleId, buffTypeId);
    }

    @Override
    public boolean psendSBuffChangeResult(Result result) {
        if (result == null) {
            return false;
        }
        Map clientAttrs = fire.pb.effect.Module.getClientAttrs((Map)result.getChangedAttrs());
        if (clientAttrs.size() != 0) {
            Procedure.psendWhileCommit((long)this.roleId, (Protocol)new SRefreshRoleData((HashMap)clientAttrs));
        }
        SBuffChangeResult sBuffChangeResult = this.getSBuffChangeResult(result);
        if (sBuffChangeResult.addedbuffs.size() == 0 && sBuffChangeResult.deletedbuffs.size() == 0) {
            return false;
        }
        Procedure.psendWhileCommit((long)this.roleId, (Protocol)sBuffChangeResult);
        return true;
    }

    public int getAllSceneState() {
        int scenestate = 0;
        for (Integer buffId : this.getAllBuffBeans().keySet()) {
            ConstantlyBuffConfig buffcfg = Module.getInstance().getDefaultCBuffConfig(buffId);
            if (buffcfg.getSceneId() <= 0) continue;
            scenestate |= buffcfg.getSceneId();
        }
        return scenestate;
    }

    public void psendCBuffWhileOnline() {
        Result result = new Result(true);
        for (xbean.Buff xbuff : this.getAllBuffBeans().values()) {
            result.addAddedBuff(xbuff);
        }
        this.psendSBuffChangeResult(result);
    }

    @Override
    public SBuffChangeResult getSBuffChangeResult(Result result) {
        ConstantlyBuffConfig cbuffconf;
        SBuffChangeResult sBuffChangeResult = new SBuffChangeResult();
        sBuffChangeResult.agenttype = this.agentType;
        sBuffChangeResult.id = this.roleId;
        sBuffChangeResult.petid = -1;
        for (Integer n : result.getDeletedBuffs()) {
            cbuffconf = Module.getInstance().getDefaultCBuffConfig(n);
            if (!cbuffconf.isSendClient()) continue;
            sBuffChangeResult.deletedbuffs.add(n);
        }
        for (Map.Entry entry : result.getAddedBuffMap().entrySet()) {
            cbuffconf = Module.getInstance().getDefaultCBuffConfig((Integer)entry.getKey());
            if (!cbuffconf.isSendClient()) continue;
            if (!cbuffconf.isShowTime()) {
                ((Buff)entry.getValue()).time = 0L;
            }
            sBuffChangeResult.addedbuffs.put((Integer)entry.getKey(), (Buff)entry.getValue());
        }
        return sBuffChangeResult;
    }

    public StoredBuffRole getStoredBuffRole() {
        return this.storedBuffRole;
    }

    public long getRoleId() {
        return this.roleId;
    }

    public void setRoleId(long roleId) {
        this.roleId = roleId;
    }

    public BuffRole getBuffRoleBean() {
        return this.buffRoleBean;
    }

    @Override
    public Role getERole() {
        return new RoleImpl(this.roleId, this.readonly);
    }

    @Override
    public Result removeBuffsWhileBattleEnd() {
        Result result = super.removeBuffsWhileBattleEnd();
        if (result.isSuccess()) {
            for (Map.Entry entry : this.agent.getBattleendclear().entrySet()) {
                switch ((Integer)entry.getValue()) {
                    case 1: {
                        result.updateResult(this.removeTimeoutCBuff((Integer)entry.getKey()));
                        break;
                    }
                    case 2: {
                        result.updateResult(this.processCBuff((Integer)entry.getKey()));
                    }
                }
            }
            this.agent.getBattleendclear().clear();
        }
        return result;
    }

    @Override
    public void startBuffTimer(ConstantlyBuff buff) {
        if (buff.getTime() > 0L) {
            Long futureId = (Long)this.getAgent().getTimerfutures().get(buff.getId());
            if (futureId != null) {
                ScheduledFuture future = ScheduledFutureMap.getInstance().get(futureId.longValue());
                if (future != null) {
                    future.cancel(true);
                }
                Module.logger.error((Object)("Buff" + buff.getId() + "startTimer时，已经有了旧的。"));
            }
            BuffTimer newtimer = null;
            newtimer = buff instanceof PeriodBuff ? this.getBuffTimer(buff.getId(), ((PeriodBuff)buff).getInitialDelay(), ((PeriodBuff)buff).getPeriod(), ((PeriodBuff)buff).getPeriodCount()) : this.getBuffTimer(buff.getId(), buff.getTime());
            if (newtimer == null) {
                logger.error((Object)"!!!Buff Timer is null.");
                throw new NullPointerException("没有buff timer!!");
            }
            if (newtimer.schedule()) {
                long now = System.currentTimeMillis();
                buff.setImpactTime(now);
                long futurekey = ScheduledFutureMap.getInstance().insert(newtimer.getFuture());
                this.getAgent().getTimerfutures().put(buff.getId(), futurekey);
            }
        }
    }

    @Override
    public int checkBuffClash(int buffOpId) {
        int clashId = super.checkBuffClash(buffOpId);
        if (clashId > 0) {
            this.sendBuffClashMsg(buffOpId, clashId);
            return clashId;
        }
        BuffClashs buffclashs = Module.getInstance().getBuffClashs(buffOpId);
        if (buffclashs == null) {
            return 0;
        }
        clashId = buffclashs.checkStateClash(this.roleId);
        if (clashId > 0) {
            this.sendBuffClashMsg(buffclashs, clashId);
            return clashId;
        }
        fire.pb.map.Role maprole = RoleManager.getInstance().getRoleByID(this.roleId);
        if (maprole == null) {
            return clashId;
        }
        if (buffclashs.checkMapClash((int)maprole.getScene())) {
            this.sendBuffClashMsg(buffclashs, (int)maprole.getScene());
            return (int)maprole.getScene();
        }
        return 0;
    }

    public void sendBuffClashMsg(int buffOpId, int clashId) {
        if (clashId == 0) {
            return;
        }
        this.sendBuffClashMsg(Module.getInstance().getBuffClashs(buffOpId), clashId);
    }

    public void sendBuffClashMsg(BuffClashs buffclashs, int clashId) {
        if (buffclashs == null) {
            return;
        }
        Integer msgId = buffclashs.getClashMsgIds().get(clashId);
        if (msgId != null) {
            MessageMgr.sendMsgNotify((long)this.roleId, (int)msgId, null);
        } else if (buffclashs.getDefaultClashMsgId() != 0) {
            MessageMgr.sendMsgNotify((long)this.roleId, (int)buffclashs.getDefaultClashMsgId(), null);
        }
    }

    @Override
    public void addSceneState(ConstantlyBuffConfig buffcfg) {
        if (buffcfg.getSceneId() > 0) {
            GsClient.pSendWhileCommit((Protocol)new GAddSceneState(this.roleId, buffcfg.getSceneId()));
        }
    }

    @Override
    public void removeSceneState(ConstantlyBuffConfig buffcfg) {
        if (buffcfg.getSceneId() > 0) {
            GsClient.pSendWhileCommit((Protocol)new GRemoveSceneState(this.roleId, buffcfg.getSceneId()));
        }
    }
}

